#' calculate quality scores for chromatographic peaks
#'
#' This function calculates a set of quality scores for chromatographic peaks 
#' using quantifier and qualifier traces.
#'
#' @param x1 quantifier chromatogram
#' @param x2 qualifier chromatogram
#' @param x3 13C qualifier chromatogram
#' @param peakstart index of peak start
#' @param peaktop index of peak top
#' @param peakend index of peak end
#' @param nowusetrace 3 element logical vector indicating if x1/x2/x3 should be used (TRUE) or ignored (FALSE)
#' @param im index of current metabolite
#' @param metab metab list generated by read_metabdb()
#' @param prm prm list generated by initialize_prm()
#' @param rtshift known shift in retention time relative to reference chromatogram
#' @param rangestart offset between peakstart/peaktop/peakend and start of x1/x2/x3
#'
#' @return qs_list named list of quality scores
#'
#' @export
get_quality_scores <- function(x1, x2, x3, peakstart, peaktop, peakend, nowusetrace, im, metab, prm, rtshift = 0, rangestart = 0) {

  # peakstart <- peakstarts[ip]
  # peaktop <- peaktops[ip]
  # peakend <- peakends[ip]

  # ideas for future work:
  # add QS: requires refsample & rtshift: the peak shift quadratic fit quality 
  #         (residual of the fit, same for all samples)
  #         alternatively: for each sample/metabolite: residual of shift fit
  # add QS: requires complete batch: RT consistency across batch
  

  # names must start with "QS" in order for the training script to work properly
  qs_list <- list( 'QS_cor123' =  0,
                   'QS_T.o' =  0,
                   'QS_T.h' =  0,
                   'QS_T.l' =  0,
                   'QS_dRT' =  0,
                   'QS_w' =  0,
                   'QS_cor12' =  0,
                   'QS_cor13' =  0,
                   'QS_cor23' =  0,
                   'QS_height' =  0,
                   'QS_relRT' =  0,
                   'QS_T.o2' = 0,
                   'QS_T.o3' = 0,
                   'QS_gauss' = 0,
                   'QS_1vs2' = 0 ,
                   'QS_dRTs' = 0,
                   'QS_d1s' = 0,
                   'QS_d1e' = 0,
                   'QS_d2s' = 0,
                   'QS_d2e' = 0,
                   'QS_fwhm' = 0,
                   'QS_tri' = 0, 
                   'QS_jag' = 0)

  if (!is.na(peaktop)) {
    if ((peakstart < peaktop) && (peakend > peaktop) ) {
      
      # if peakstart is outside measured range, put to first value of measured range
      # but only if there actually is measured data
      if (sum(x1 > 0, na.rm = TRUE) > 5) {
        datarange = which( x1 > 0 )
        if (peakstart < min(datarange) )  peakstart <- datarange[1]
        if (peakend > max(datarange) )  peakend <- max(datarange)
      }

      # QS1: average correlation (quant, qual12c, qual13c)
      nowcor <- suppressWarnings(cor(cbind(x1[peakstart:peakend],x2[peakstart:peakend],x3[peakstart:peakend]),use="everything") ) #use="complete.obs"
      cor_value <-  0.5*(mean(c(nowcor[1, 2:3], nowcor[2,3]), na.rm = TRUE)+1)
      qs_list$QS_cor123 <- check_qs_value(cor_value)


    # QS2 ratio peak top to highest point outside of series
      t_o_value <- max(c(x1[peaktop] / (x1[peaktop] + max(x1[c(1:(max(c(peakstart-1,1))),(min(c(peakend+1,length(x1)))):length(x1))], na.rm = TRUE)),0))
      qs_list$QS_T.o <- check_qs_value(t_o_value)


    # QS3 ratio peak top/max(peakend,peakstart)
      t_b_h_value <- ((2 * x1[peaktop])/ (x1[peaktop] + max(x1[peakstart],x1[peakend])) ) -1
      qs_list$QS_T.h <- check_qs_value(t_b_h_value)


    # QS4 ratio peak top/min(peakend,peakstart)
      t_b_l_value <- ((2 * x1[peaktop])/ (x1[peaktop] + min(x1[peakstart],x1[peakend])) ) -1
      qs_list$QS_T.l <- check_qs_value(t_b_l_value)


    # QS5 deviation from expected RT
      peaktopa <- which.min(abs(prm$unirt - metab[[im]]$RT)) # round(metab[[im]]$RT * 60 * prm$samplingfrequency)
      dRT_value <- (1/(1+abs(prm$unirt[peaktop + rangestart] - prm$unirt[peaktopa]) ))^2
      qs_list$QS_dRT <- check_qs_value(dRT_value)

      # deviation from predicted RT
      if (prm$ml_type != 'mltrain_pick') {
        peaktopa <- which.min(abs(prm$unirt - metab[[im]]$RT)) + rtshift # round(metab[[im]]$RT * 60 * prm$samplingfrequency) + rtshift
        peaktopa <- min(max(c(1, peaktopa + rangestart)) , prm$nscan)
        dRT_value <- (1/(1+abs(prm$unirt[peaktop] - prm$unirt[peaktopa]) ))^2
        qs_list$QS_dRTs <- check_qs_value(dRT_value)
      }

    # QS6 widthscore
      if (peakstart != peakend){
        widthscore <- 1/ (1+(prm$unirt[peakend] - prm$unirt[peakstart]))
      }else{
        widthscore <- 0
      }
      qs_list$QS_w <- check_qs_value(widthscore)
      

      #Check if nowusetrace is 0
      if (nowusetrace[1] == FALSE || nowusetrace[2] == FALSE) {
        if(prm$ml_type == "mltrain_pick"){
          cor_value <- 0
        }else{
          cor_value <- prm$median_values$QS_cor12
        }
      }else{
        cor_value <- suppressWarnings(cor(x1[peakstart:peakend],x2[peakstart:peakend],use="everything") * 0.5 + 0.5 )
      }
      qs_list$QS_cor12 <- check_qs_value(cor_value)


      #Check if nowusetrace is 0
      if (nowusetrace[1] == FALSE || nowusetrace[3] == FALSE) {
        if(prm$ml_type == "mltrain_pick"){
          cor_value <- 0
        }else{
          cor_value <- prm$median_values$QS_cor13
        }
      }else{
        cor_value <- suppressWarnings(cor(x1[peakstart:peakend],x3[peakstart:peakend],use="everything") * 0.5 + 0.5 )
      }
      qs_list$QS_cor13 <- check_qs_value(cor_value)

      #Check if nowusetrace is 0
      if (nowusetrace[2] == FALSE || nowusetrace[3] == FALSE) {
        if(prm$ml_type == "mltrain_pick"){
          cor_value <- 0
        }else{
          cor_value <- prm$median_values$QS_cor23
        }
      }else{
        cor_value <- suppressWarnings(cor(x2[peakstart:peakend],x3[peakstart:peakend],use="everything") * 0.5 + 0.5 )
      }
      qs_list$QS_cor23 <- check_qs_value(cor_value)


    # QS10 Peak intensity
      peak_int_value <- log10(x1[peaktop])
      qs_list$QS_height <- check_qs_value(peak_int_value)


    # QS11 retention time relative to method length
      RT_value <- prm$unirt[peaktop] / max(prm$unirt, na.rm = TRUE)
      qs_list$QS_relRT <- check_qs_value(RT_value)


    # QS12 | QS13 (12c & 13c qualifier): ratio peak top to highest point outside
      if (is.null(x2) || nowusetrace[2] == FALSE || (peakstart == peakend)){
        if(prm$ml_type == "mltrain_pick"){
          qual_t_o_value <- 0
        }else{
          qual_t_o_value <- prm$median_values$QS_T.o2
        }
      }else{
        qual_t_o_value <- max((max(x2[peakstart:peakend],na.rm=TRUE) / ( (max(x2[peakstart:peakend],na.rm=TRUE) + max(c(x2[1:max(c(peakstart-1),1)],x2[min(c(peakend+1,length(x2))):length(x2)]),na.rm=TRUE)) )),0)
      }
      qs_list$QS_T.o2 <- check_qs_value(qual_t_o_value)


      # gaussean shape of quantifier
      nowoutsidepoints <- which(x1 < 0.5*x1[peaktop]) - peaktop
      nowfwhm <- suppressWarnings(min(nowoutsidepoints[nowoutsidepoints > 0]) - max(nowoutsidepoints[nowoutsidepoints < 0]))
      qs_list$QS_gauss <- suppressWarnings(check_qs_value(max(c(0,cor(x1[peakstart:peakend], dnorm(peakstart:peakend,mean=(peaktop+1),sd=(0.5*nowfwhm)) )),na.rm=TRUE) ) )# correlation to gaussian peak


      # ratio quant/12C_qual
      # Check if nowusetrace is 0
      if (length(metab[[im]]$quant$intens) == 0 || length(metab[[im]]$qual12c$intens) == 0){
        if(prm$ml_type == "mltrain_pick"){
          ratio_value <- 0
        }else{
          ratio_value <- prm$median_values$QS_1vs2
        }
      } else {

        if (nowusetrace[1] == FALSE || nowusetrace[2] == FALSE ||
            is.na(metab[[im]]$quant$intens) || is.na(metab[[im]]$qual12c$intens[1]) ) {
          if(prm$ml_type == "mltrain_pick"){
            ratio_value <- 0
          }else{
            ratio_value <- prm$median_values$QS_1vs2
          }
        } else {
          ratio_value <- (1 / (1 + abs( log(x1[peaktop] / x2[peaktop], 2) -
                                        log(metab[[im]]$quant$intens / metab[[im]]$qual12c$intens[1],2))^2 ) )^2
        }
      }
      qs_list$QS_1vs2 <- check_qs_value(ratio_value)


      if (is.null(x3) || nowusetrace[3] == FALSE || (peakstart == peakend)){
        if(prm$ml_type == "mltrain_pick"){
          qual_t_o_value <- 0
        }else{
          qual_t_o_value <- prm$median_values$QS_T.o3
        }
      }else{
        qual_t_o_value <- max((max(x3[peakstart:peakend],na.rm=TRUE) / ( (max(x3[peakstart:peakend],na.rm=TRUE) + max(c(x3[1:max(c(peakstart-1),1)],x3[min(c(peakend+1,length(x3))):length(x3)]),na.rm=TRUE)) )),0)
      }
      qs_list$QS_T.o3 <- check_qs_value(qual_t_o_value)
      
      # slope and second derivative of quantifier at peak start and peak end
      x1a <- diff(x1)
      x1b <- c(NA, diff(x1a))
      qs_list$QS_d1s <- check_qs_value(x1a[peakstart-1] / max(abs(x1a),na.rm = TRUE))
      qs_list$QS_d1e <- check_qs_value(x1a[peakend] / max(abs(x1a),na.rm = TRUE))
      qs_list$QS_d2s <- check_qs_value(x1b[peakstart] / max(abs(x1b),na.rm = TRUE))
      qs_list$QS_d2e <- check_qs_value(x1b[peakend] / max(abs(x1b),na.rm = TRUE))
      

    } # endif peaktop is between peakstart and peakend
  } # endif !is.na(peaktop)

  
  # QS full width at half maximum
  if (peakstart != peakend){
    abovehalf <- which(x1 > 0.5*x1[peaktop])
    suppressWarnings(fwhm <- 1 / (1 + (prm$unirt[max(abovehalf[abovehalf < peakend])] - 
                        prm$unirt[min(abovehalf[abovehalf > peakstart])]) ) )
  }else{
    fwhm <- 0
  }
  qs_list$QS_fwhm <- check_qs_value(fwhm)
  
  
  # QS similiarity to triangular shape
  if (peakstart != peakend){
    tr_area <- 0.5 * x1[peaktop] * (peakend - peakstart)
    p_area <- sum(x1[peakstart:peakend], na.rm = TRUE) - 
      min(x1[peakstart:peakend], na.rm = TRUE) * (peakend-peakstart)
    tri <- 1- (abs(tr_area - p_area)/tr_area)
  }else{
    tri <- 0
  }
  qs_list$QS_tri <- check_qs_value(tri)
  
  # QS jaggedness
  if (peakstart != peakend){
    # number of changes in direction normalized to peak width
    jag <- 1 - (sum(abs(diff(sign(diff(x1[peakend:peakstart])))) == 2) / 
               (peakend - peakstart) )
  }else{
    jag <- 0
  }
  qs_list$QS_jag <- check_qs_value(jag)
  
  
  # return qs_list
  qs_list

} # endfunction

